<?php

drupal_add_css( drupal_get_path('module', 'oauth_server_sso'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
drupal_add_css( drupal_get_path('module', 'oauth_server_sso'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
drupal_add_css( drupal_get_path('module', 'oauth_server_sso'). '/css/mo-card.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

drupal_add_js(drupal_get_path('module', 'oauth_server_sso') . '/js/dru_visual_tour.js');

    $Tour_taken = variable_get('mo_saml_tourTaken_' . getPage_name(), false);

    drupal_add_js(array('moTour' => array(
        'pageID' => getPage_name(),
        'tourData' => getTourData(getPage_name(),$Tour_taken),
        'tourTaken' => $Tour_taken,
        'addID' => addID(),
        'pageURL' => $_SERVER['REQUEST_SCHEME'] . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'],

    )), array('type' => 'setting'));


if(isset($_POST['doneTour']) && isset($_POST['pageID']))
{
    variable_set('mo_saml_tourTaken_'.$_POST['pageID'], $_POST['doneTour']);
}

function getPage_name()
{
    $link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
    $exploded = explode('/', $link);
    $l_url = end($exploded);
    $l_url = multiexplode(array("?","%","#",":","="),$l_url);
    $f_url = $l_url[0];
    return $f_url;
}

function multiexplode ($delimiters,$string)
{
    $ready = str_replace($delimiters, $delimiters[0], $string);
    $launch = explode($delimiters[0], $ready);
    return  $launch;
}

function mo_visual_tour()
{
    $firstTour = true;
    echo '<div id="restart_tour_button" class="mo-otp-help-button static" style="margin-right:10px;z-index:10">
    <button class="button button-primary button-large">
    <span class="dashicons dashicons-controls-repeat" style="margin:5% 0 0 0;"></span>
        '.mo_("Restart Tour").'
    </button>
    </div>';
}

function addID()
{
    $idArray = array(
        array(
            'selector'  =>'.tabs li:nth-of-type(1)>a',
            'newID'     =>'mo_vt_congig_oauth',
        ),
        array(
            'selector'  =>'.tabs li:nth-of-type(2)>a',
            'newID'     =>'mo_vt_settings',
        ),
        array(
            'selector'  =>'.tabs li:nth-of-type(3)>a',
            'newID'     =>'mo_vt_licensing_plans',
        ),
        array(
            'selector'  =>'.tabs li:nth-of-type(4)>a',
            'newID'     =>'mo_vt_support',
        ),
        array(
            'selector'  =>'.tabs li:nth-of-type(5)>a',
            'newID'     =>'mo_vt_account',
        ),

    );
    return $idArray;
}


function getTourData($pageID,$Tour_Taken)
{
    $tourData = array();
    $stat = variable_get('oauth_server_sso_add_client_status');

    if($Tour_Taken == FALSE) {
        $tourData['oauth_server_sso'] = array(
            0 => array(
                'targetE'       => 'mo_vt_congig_oauth',
                'pointToSide'   => 'up',
                'titleHTML'     => '<h1>Configure OAuth</h1>',
                'contentHTML'   => 'Configure your OAuth Server with OAuth Client here to perform SSO.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            1 => array(
                'targetE'       => 'mo_vt_settings',
                'pointToSide'   => 'up',
                'titleHTML'     => '<h1>General Settings</h1>',
                'contentHTML'   => 'You can customize your Token Length and Token Expiry time here',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'largemedium',
                'action'        => '',
            ),
            2 => array(
                'targetE'       => 'mo_vt_licensing_plans',
                'pointToSide'   => 'up',
                'titleHTML'     => '<h1>Upgrade here</h1>',
                'contentHTML'   => 'You can see the complete list of features that we provide in our various plans and can also upgrade to any of them.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'largemedium',
                'action'        => '',
            ),
            3 => array(
                'targetE'       => 'mo_vt_support',
                'pointToSide'   =>  'up',
                'titleHTML'     =>  '<h1>Need Help?</h1>',
                'contentHTML'   =>  'You can always reach out to us instantly in case you face any issues or have any questions in mind.',
                'ifNext'        =>  true,
                'buttonText'    =>  'Next',
                'img'           =>  array(),
                'cardSize'      =>  'largemedium',
                'action'        =>  '',
            ),
            4 => array(
                'targetE'       => 'mo_vt_account',
                'pointToSide'   => 'right',
                'titleHTML'     => '<h1>Register/Login</h1>',
                'contentHTML'   => 'You can Register/Login here with miniOrange.',
                'ifNext'        => true,
                'buttonText'    => 'End Tour',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            5 => array(
                'targetE'       => 'firstname',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Client Name</h1>',
                'contentHTML'   => 'Enter your OAuth Client Name here.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            6 => array(
                'targetE'       => 'redirecturl',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Authorized Redirect URL</h1>',
                'contentHTML'   => 'Enter the Callback/Redirect URL that you got from your OAuth Client here.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            7 => array(
                'targetE'       => 'button_config_center',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Next</h1>',
                'contentHTML'   => 'Click on Next button to Save your configurations.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            8 => array(
                'targetE'       => 'ma_saml_support_query',
                'pointToSide'   => 'right',
                'titleHTML'     => '<h1>Need Help?</h1>',
                'contentHTML'   => 'Get in touch with us and we will help you setup the module in no time.',
                'ifNext'        => true,
                'buttonText'    => 'End Tour',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
                'ifskip'        =>  'hidden',
            ),
        );
    }else {
        $tourData['oauth_server_sso'] = array(
            0 => array(
                'targetE'       => 'firstname',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Client Name</h1>',
                'contentHTML'   => 'Enter your OAuth Cleint Name here.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            1 => array(
                'targetE'       => 'redirecturl',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Authorized Redirect URL</h1>',
                'contentHTML'   => 'Enter the Callback/Redirect URL that you got from your OAuth Client here.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            2 => array(
                'targetE'       => 'button_config_center',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Next</h1>',
                'contentHTML'   => 'Click on Next button to Save your configurations.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
            ),
            3 => array(
                'targetE'       => 'ma_saml_support_query',
                'pointToSide'   => 'right',
                'titleHTML'     => '<h1>Need Help?</h1>',
                'contentHTML'   => 'Get in touch with us and we will help you setup the module in no time.',
                'ifNext'        => true,
                'buttonText'    => 'End Tour',
                'img'           => array(),
                'cardSize'      => 'medium',
                'action'        => '',
                'ifskip'        =>  'hidden',
            ),
        );
    }

    if($stat != '' || $stat == 'review') {
        $tourData['oauth_server_sso'] = array(
            0 => array(
                'targetE'       => 'clientID',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Client ID</h1>',
                'contentHTML'   => 'Provide this Client ID to your OAuth Client to Configure with OAuth Server.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'largemedium',
                'action'        => '',
            ),
            1 => array(
                'targetE'       => 'clientSecret',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Client Secret</h1>',
                'contentHTML'   => 'Provide this Client Secret to your OAuth Client to Configure with OAuth Server.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'largemedium',
                'action'        => '',
            ),
            2 => array(
                'targetE'       => 'button_config_vt',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Delete Client</h1>',
                'contentHTML'   => 'Click here for Delete your OAuth Server Configuration.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'largemedium',
                'action'        => '',
            ),
            3 => array(
                'targetE'       => 'button_config_update_vt',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>Update</h1>',
                'contentHTML'   => 'Click here for Update your configuration settings.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'largemedium',
                'action'        => '',
            ),
            4 => array(
                'targetE'       => 'endpointsUrl',
                'pointToSide'   => 'left',
                'titleHTML'     => '<h1>How to Setup?</h1>',
                'contentHTML'   => 'These are the endpoints and scopes you need to provide your client so that you can use your Drupal Site for Single Sign-On!.',
                'ifNext'        => true,
                'buttonText'    => 'Next',
                'img'           => array(),
                'cardSize'      => 'largemedium',
                'action'        => '',
            ),
            5 => array(
                'targetE'       => 'ma_saml_support_query',
                'pointToSide'   => 'right',
                'titleHTML'     => '<h1>Need Help?</h1>',
                'contentHTML'   => 'Get in touch with us and we will help you setup the plugin in no time.',
                'ifNext'        => true,
                'buttonText'    => 'End Tour',
                'img'           => array(),
                'cardSize'      => 'medium',
                'ifskip'        =>  'hidden',
            ),

        );
    }
    return $tourData[$pageID];
}

/*
                            ********************************
                                    array terms :
                            ********************************
pageID              -   your Page ID, contains array of popups
0                   -   Popup/card number, goes from zero to n. For next Tab card use 'nextCard' instead of number
targetE             -   Element to target to. Has to be element ID without #. If no ID, add one. Empty For none, shows in centre of screen if empty
pointToSide         -   Direction of arrow to point to (up,down,left,right), for no arrow-keep empty (places at center keep targetE empty) //look at this fix
titleHTML           -   Title of card, can be HTML code
contentHTML         -   Content of card, can be HTML code
ifNext              -   if to show(true) Next Button or not(false), Keep False for Card Number('nextTab')
buttonText          -   Next Button Text
img                 -   image(icon) attributes ('src' should not be 'empty' with 'visible' true)
                        src     -   url of image(best for ico/transparent png) icon(https://visualpharm.com/assets/262/Comments-595b40b65ba036ed117d3e48.svg)
                        visible -   to show image or not, true or false
cardSize            -   Card has 3 difined sizes- big, medium and small. Recomended not to use image with small
nextTab             -   This is special card used if you want user to move to next tab during tour, disabled during restart tour

 */